Index: /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_core.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_core.c	(revision 502)
+++ /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_core.c	(revision 503)
@@ -1846,20 +802,253 @@
 
 
-/**
- * Get SIP endpoint instance.
- * Only valid after pjsua_init().
- */
-PJ_DEF(pjsip_endpoint*) pjsua_get_pjsip_endpt(void)
-{
-    return pjsua.endpt;
-}
-
-/**
- * Get media endpoint instance.
- * Only valid after pjsua_init().
- */
-PJ_DEF(pjmedia_endpt*) pjsua_get_pjmedia_endpt(void)
-{
-    return pjsua.med_endpt;
-}
-
+/*
+ * Register transport that has been created by application.
+ */
+PJ_DEF(pj_status_t) pjsua_transport_register( pjsip_transport *tp,
+					      pjsua_transport_id *p_id)
+{
+    unsigned id;
+
+    PJSUA_LOCK();
+
+    /* Find empty transport slot */
+    for (id=0; id < PJ_ARRAY_SIZE(pjsua_var.tpdata); ++id) {
+	if (pjsua_var.tpdata[id].tp == NULL)
+	    break;
+    }
+
+    if (id == PJ_ARRAY_SIZE(pjsua_var.tpdata)) {
+	pjsua_perror(THIS_FILE, "Error creating transport", PJ_ETOOMANY);
+	PJSUA_UNLOCK();
+	return PJ_ETOOMANY;
+    }
+
+    /* Save the transport */
+    pjsua_var.tpdata[id].tp = tp;
+
+    /* Return the ID */
+    if (p_id) *p_id = id;
+
+    PJSUA_UNLOCK();
+
+    return PJ_SUCCESS;
+}
+
+
+/*
+ * Enumerate all transports currently created in the system.
+ */
+PJ_DEF(pj_status_t) pjsua_enum_transports( pjsua_transport_id id[],
+					   unsigned *p_count )
+{
+    unsigned i, count;
+
+    PJSUA_LOCK();
+
+    for (i=0, count=0; i<PJ_ARRAY_SIZE(pjsua_var.tpdata) && count<*p_count; 
+	 ++i) 
+    {
+	if (!pjsua_var.tpdata[i].tp)
+	    continue;
+
+	id[count++] = i;
+    }
+
+    *p_count = count;
+
+    PJSUA_UNLOCK();
+
+    return PJ_SUCCESS;
+}
+
+
+/*
+ * Get information about transports.
+ */
+PJ_DEF(pj_status_t) pjsua_transport_get_info( pjsua_transport_id id,
+					      pjsua_transport_info *info)
+{
+    pjsip_transport *tp;
+
+    pj_memset(info, 0, sizeof(*info));
+
+    /* Make sure id is in range. */
+    PJ_ASSERT_RETURN(id>=0 && id<PJ_ARRAY_SIZE(pjsua_var.tpdata), PJ_EINVAL);
+
+    /* Make sure that transport exists */
+    PJ_ASSERT_RETURN(pjsua_var.tpdata[id].tp != NULL, PJ_EINVAL);
+
+    PJSUA_LOCK();
+
+    tp = pjsua_var.tpdata[id].tp;
+    if (tp == NULL) {
+	PJSUA_UNLOCK();
+	return PJ_EINVALIDOP;
+    }
+    
+    info->id = id;
+    info->type = tp->key.type;
+    info->type_name = pj_str(tp->type_name);
+    info->info = pj_str(tp->info);
+    info->flag = tp->flag;
+    info->addr_len = tp->addr_len;
+    info->local_addr = tp->local_addr;
+    info->local_name = tp->local_name;
+    info->usage_count = pj_atomic_get(tp->ref_cnt);
+
+    PJSUA_UNLOCK();
+
+    return PJ_EINVALIDOP;
+}
+
+
+/*
+ * Disable a transport or re-enable it.
+ */
+PJ_DEF(pj_status_t) pjsua_transport_set_enable( pjsua_transport_id id,
+						pj_bool_t enabled)
+{
+    /* Make sure id is in range. */
+    PJ_ASSERT_RETURN(id>=0 && id<PJ_ARRAY_SIZE(pjsua_var.tpdata), PJ_EINVAL);
+
+    /* Make sure that transport exists */
+    PJ_ASSERT_RETURN(pjsua_var.tpdata[id].tp != NULL, PJ_EINVAL);
+
+
+    /* To be done!! */
+    PJ_TODO(pjsua_transport_set_enable);
+
+    return PJ_EINVALIDOP;
+}
+
+
+/*
+ * Close the transport.
+ */
+PJ_DEF(pj_status_t) pjsua_transport_close( pjsua_transport_id id,
+					   pj_bool_t force )
+{
+    /* Make sure id is in range. */
+    PJ_ASSERT_RETURN(id>=0 && id<PJ_ARRAY_SIZE(pjsua_var.tpdata), PJ_EINVAL);
+
+    /* Make sure that transport exists */
+    PJ_ASSERT_RETURN(pjsua_var.tpdata[id].tp != NULL, PJ_EINVAL);
+
+
+    /* To be done!! */
+
+
+    PJ_TODO(pjsua_transport_close);
+
+    return PJ_EINVALIDOP;
+}
+
+
+/*
+ * Add additional headers etc in msg_data specified by application
+ * when sending requests.
+ */
+void pjsua_process_msg_data(pjsip_tx_data *tdata,
+			    const pjsua_msg_data *msg_data)
+{
+    pj_bool_t allow_body;
+    const pjsip_hdr *hdr;
+
+    if (!msg_data)
+	return;
+
+    hdr = msg_data->hdr_list.next;
+    while (hdr && hdr != &msg_data->hdr_list) {
+	pjsip_hdr *new_hdr;
+
+	new_hdr = pjsip_hdr_clone(tdata->pool, hdr);
+	pjsip_msg_add_hdr(tdata->msg, new_hdr);
+
+	hdr = hdr->next;
+    }
+
+    allow_body = (tdata->msg->body == NULL);
+
+    if (allow_body && msg_data->content_type.slen && msg_data->msg_body.slen) {
+	pjsip_media_type ctype;
+	pjsip_msg_body *body;	
+
+	pjsua_parse_media_type(tdata->pool, &msg_data->content_type, &ctype);
+	body = pjsip_msg_body_create(tdata->pool, &ctype.type, &ctype.subtype,
+				     &msg_data->msg_body);
+	tdata->msg->body = body;
+    }
+}
+
+
+/*
+ * Add route_set to outgoing requests
+ */
+void pjsua_set_msg_route_set( pjsip_tx_data *tdata,
+			      const pjsip_route_hdr *route_set )
+{
+    const pjsip_route_hdr *r;
+
+    r = route_set->next;
+    while (r != route_set) {
+	pjsip_route_hdr *new_r;
+
+	new_r = pjsip_hdr_clone(tdata->pool, r);
+	pjsip_msg_add_hdr(tdata->msg, (pjsip_hdr*)new_r);
+
+	r = r->next;
+    }
+}
+
+
+/*
+ * Simple version of MIME type parsing (it doesn't support parameters)
+ */
+void pjsua_parse_media_type( pj_pool_t *pool,
+			     const pj_str_t *mime,
+			     pjsip_media_type *media_type)
+{
+    pj_str_t tmp;
+    char *pos;
+
+    pj_memset(media_type, 0, sizeof(*media_type));
+
+    pj_strdup_with_null(pool, &tmp, mime);
+
+    pos = pj_strchr(&tmp, '/');
+    if (pos) {
+	media_type->type.ptr = tmp.ptr; 
+	media_type->type.slen = (pos-tmp.ptr);
+	media_type->subtype.ptr = pos+1; 
+	media_type->subtype.slen = tmp.ptr+tmp.slen-pos-1;
+    } else {
+	media_type->type = tmp;
+    }
+}
+
+
+/*
+ * Verify that valid SIP url is given.
+ */
+PJ_DEF(pj_status_t) pjsua_verify_sip_url(const char *c_url)
+{
+    pjsip_uri *p;
+    pj_pool_t *pool;
+    char *url;
+    int len = (c_url ? pj_ansi_strlen(c_url) : 0);
+
+    if (!len) return -1;
+
+    pool = pj_pool_create(&pjsua_var.cp.factory, "check%p", 1024, 0, NULL);
+    if (!pool) return -1;
+
+    url = pj_pool_alloc(pool, len+1);
+    pj_ansi_strcpy(url, c_url);
+
+    p = pjsip_parse_uri(pool, url, len, 0);
+    if (!p || pj_stricmp2(pjsip_uri_get_scheme(p), "sip") != 0)
+	p = NULL;
+
+    pj_pool_release(pool);
+    return p ? 0 : -1;
+}
Index: /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_im.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_im.c	(revision 502)
+++ /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_im.c	(revision 503)
@@ -18,15 +18,8 @@
  */
 #include <pjsua-lib/pjsua.h>
-#include <pj/log.h>
-#include "pjsua_imp.h"
-
-/*
- * pjsua_im.c
- *
- * To handle incoming MESSAGE outside dialog.
- * Incoming MESSAGE inside dialog is hanlded in pjsua_call.c.
- */
-
-#define THIS_FILE   "pjsua_im.c"
+#include <pjsua-lib/pjsua_internal.h>
+
+
+#define THIS_FILE   "pjsua_im.h"
 
 
@@ -50,4 +43,5 @@
 /* Proto */
 static pj_bool_t im_on_rx_request(pjsip_rx_data *rdata);
+
 
 /* The module instance. */
@@ -137,28 +131,46 @@
  *	    This may trigger pjsua_ui_on_pager() or pjsua_ui_on_typing().
  */
-void pjsua_im_process_pager(int call_index, const pj_str_t *from,
+void pjsua_im_process_pager(int call_id, const pj_str_t *from,
 			    const pj_str_t *to, pjsip_rx_data *rdata)
 {
+    pjsip_contact_hdr *contact_hdr;
+    pj_str_t contact;
     pjsip_msg_body *body = rdata->msg_info.msg->body;
 
     /* Body MUST have been checked before */
     pj_assert(body != NULL);
+
+
+    /* Build remote contact */
+    contact_hdr = pjsip_msg_find_hdr(rdata->msg_info.msg, PJSIP_H_CONTACT,
+				     NULL);
+    if (contact_hdr) {
+	contact.ptr = pj_pool_alloc(rdata->tp_info.pool, 
+				    PJSIP_MAX_URL_SIZE);
+	contact.slen = pjsip_uri_print(PJSIP_URI_IN_CONTACT_HDR,
+				       contact_hdr->uri, contact.ptr,
+				       PJSIP_MAX_URL_SIZE);
+    } else {
+	contact.slen = 0;
+    }
+
 
     if (pj_stricmp(&body->content_type.type, &STR_MIME_TEXT)==0 &&
 	pj_stricmp(&body->content_type.subtype, &STR_MIME_PLAIN)==0)
     {
-	pj_str_t text;
-
-	/* Build the text. */
-	text.ptr = rdata->msg_info.msg->body->data;
-	text.slen = rdata->msg_info.msg->body->len;
-
-	if (pjsua.cb.on_pager)
-	    (*pjsua.cb.on_pager)(call_index, from, to, &text);
+	const pj_str_t mime_text_plain = pj_str("text/plain");
+	pj_str_t text_body;
+	
+	/* Save text body */
+	text_body.ptr = rdata->msg_info.msg->body->data;
+	text_body.slen = rdata->msg_info.msg->body->len;
+
+	if (pjsua_var.ua_cfg.cb.on_pager) {
+	    (*pjsua_var.ua_cfg.cb.on_pager)(call_id, from, to, &contact, 
+					    &mime_text_plain, &text_body);
+	}
 
     } else {
-
 	/* Expecting typing indication */
-
 	pj_status_t status;
 	pj_bool_t is_typing;
@@ -172,6 +184,8 @@
 	}
 
-	if (pjsua.cb.on_typing)
-	    (*pjsua.cb.on_typing)(call_index, from, to, is_typing);
+	if (pjsua_var.ua_cfg.cb.on_typing) {
+	    (*pjsua_var.ua_cfg.cb.on_typing)(call_id, from, to, &contact,
+					     is_typing);
+	}
     }
 
@@ -211,5 +225,5 @@
 	pj_list_push_back(&hdr_list, accept_hdr);
 
-	pjsip_endpt_respond_stateless(pjsua.endpt, rdata, 
+	pjsip_endpt_respond_stateless(pjsua_var.endpt, rdata, 
 				      PJSIP_SC_NOT_ACCEPTABLE_HERE, NULL, 
 				      &hdr_list, NULL);
@@ -220,5 +234,5 @@
      * the UI takes too long to process the message. 
      */
-    status = pjsip_endpt_respond( pjsua.endpt, NULL, rdata, 200, NULL,
+    status = pjsip_endpt_respond( pjsua_var.endpt, NULL, rdata, 200, NULL,
 				  NULL, NULL, NULL);
 
@@ -262,43 +276,156 @@
 static void im_callback(void *token, pjsip_event *e)
 {
-    pj_str_t *text = token;
+    pjsua_im_data *im_data = token;
 
     if (e->type == PJSIP_EVENT_TSX_STATE) {
 
 	pjsip_transaction *tsx = e->body.tsx_state.tsx;
+
+	/* Ignore provisional response, if any */
+	if (tsx->status_code < 200)
+	    return;
+
+
+	/* Handle authentication challenges */
+	if (e->body.tsx_state.type == PJSIP_EVENT_RX_MSG &&
+	    (tsx->status_code == 401 || tsx->status_code == 407)) 
+	{
+	    pjsip_rx_data *rdata = e->body.tsx_state.src.rdata;
+	    pjsip_tx_data *tdata;
+	    pjsip_auth_clt_sess auth;
+	    pj_status_t status;
+
+	    PJ_LOG(4,(THIS_FILE, "Resending IM with authentication"));
+
+	    /* Create temporary authentication session */
+	    pjsip_auth_clt_init(&auth,pjsua_var.endpt,rdata->tp_info.pool, 0);
+    
+	    pjsip_auth_clt_set_credentials(&auth, 
+		pjsua_var.acc[im_data->acc_id].cred_cnt,
+		pjsua_var.acc[im_data->acc_id].cred);
+
+	    status = pjsip_auth_clt_reinit_req(&auth, rdata, tsx->last_tx,
+					       &tdata);
+	    if (status == PJ_SUCCESS) {
+		pjsua_im_data *im_data2;
+
+		/* Must duplicate im_data */
+		im_data2 = pjsua_im_data_dup(tdata->pool, im_data);
+
+		/* Re-send request */
+		status = pjsip_endpt_send_request( pjsua_var.endpt, tdata, -1,
+						   im_data2, &im_callback);
+		if (status == PJ_SUCCESS) {
+		    /* Done */
+		    return;
+		}
+	    }
+	}
 
 	if (tsx->status_code/100 == 2) {
 	    PJ_LOG(4,(THIS_FILE, 
 		      "Message \'%s\' delivered successfully",
-		      text->ptr));
+		      im_data->body.ptr));
 	} else {
 	    PJ_LOG(3,(THIS_FILE, 
-		      "Failed to deliver message \'%s\': %s [st_code=%d]",
-		      text->ptr,
-		      pjsip_get_status_text(tsx->status_code)->ptr,
-		      tsx->status_code));
+		      "Failed to deliver message \'%s\': %d/%.*s",
+		      im_data->body.ptr,
+		      tsx->status_code,
+		      (int)tsx->status_text.slen,
+		      tsx->status_text.ptr));
 	}
-    }
-}
-
-
-/**
- * Send IM outside dialog.
- */
-PJ_DEF(pj_status_t) pjsua_im_send(int acc_index, const pj_str_t *dst_uri, 
-				  const pj_str_t *str)
+
+	if (pjsua_var.ua_cfg.cb.on_pager_status)
+	    pjsua_var.ua_cfg.cb.on_pager_status(im_data->call_id, 
+					        &im_data->to,
+						&im_data->body,
+						im_data->user_data,
+						tsx->status_code,
+						&tsx->status_text);
+    }
+}
+
+
+/* Outgoing typing indication callback. 
+ * (used to reauthenticate request)
+ */
+static void typing_callback(void *token, pjsip_event *e)
+{
+    pjsua_im_data *im_data = token;
+
+    if (e->type == PJSIP_EVENT_TSX_STATE) {
+
+	pjsip_transaction *tsx = e->body.tsx_state.tsx;
+
+	/* Ignore provisional response, if any */
+	if (tsx->status_code < 200)
+	    return;
+
+	/* Handle authentication challenges */
+	if (e->body.tsx_state.type == PJSIP_EVENT_RX_MSG &&
+	    (tsx->status_code == 401 || tsx->status_code == 407)) 
+	{
+	    pjsip_rx_data *rdata = e->body.tsx_state.src.rdata;
+	    pjsip_tx_data *tdata;
+	    pjsip_auth_clt_sess auth;
+	    pj_status_t status;
+
+	    PJ_LOG(4,(THIS_FILE, "Resending IM with authentication"));
+
+	    /* Create temporary authentication session */
+	    pjsip_auth_clt_init(&auth,pjsua_var.endpt,rdata->tp_info.pool, 0);
+    
+	    pjsip_auth_clt_set_credentials(&auth, 
+		pjsua_var.acc[im_data->acc_id].cred_cnt,
+		pjsua_var.acc[im_data->acc_id].cred);
+
+	    status = pjsip_auth_clt_reinit_req(&auth, rdata, tsx->last_tx,
+					       &tdata);
+	    if (status == PJ_SUCCESS) {
+		pjsua_im_data *im_data2;
+
+		/* Must duplicate im_data */
+		im_data2 = pjsua_im_data_dup(tdata->pool, im_data);
+
+		/* Re-send request */
+		status = pjsip_endpt_send_request( pjsua_var.endpt, tdata, -1,
+						   im_data2, &typing_callback);
+		if (status == PJ_SUCCESS) {
+		    /* Done */
+		    return;
+		}
+	    }
+	}
+
+    }
+}
+
+
+/*
+ * Send instant messaging outside dialog, using the specified account for
+ * route set and authentication.
+ */
+PJ_DEF(pj_status_t) pjsua_im_send( pjsua_acc_id acc_id, 
+				   const pj_str_t *to,
+				   const pj_str_t *mime_type,
+				   const pj_str_t *content,
+				   const pjsua_msg_data *msg_data,
+				   void *user_data)
 {
     pjsip_tx_data *tdata;
+    const pj_str_t mime_text_plain = pj_str("text/plain");
     const pj_str_t STR_CONTACT = { "Contact", 7 };
-    const pj_str_t mime_text = pj_str("text");
-    const pj_str_t mime_plain = pj_str("plain");
-    pj_str_t *text;
+    pjsip_media_type media_type;
+    pjsua_im_data *im_data;
     pj_status_t status;
 
+    /* To and message body must be specified. */
+    PJ_ASSERT_RETURN(to && content, PJ_EINVAL);
+
     /* Create request. */
-    status = pjsip_endpt_create_request(pjsua.endpt, &pjsip_message_method,
-					dst_uri, 
-					&pjsua.config.acc_config[acc_index].id,
-					dst_uri, NULL, NULL, -1, NULL, &tdata);
+    status = pjsip_endpt_create_request(pjsua_var.endpt, 
+					&pjsip_message_method, to, 
+					&pjsua_var.acc[acc_id].cfg.id,
+					to, NULL, NULL, -1, NULL, &tdata);
     if (status != PJ_SUCCESS) {
 	pjsua_perror(THIS_FILE, "Unable to create request", status);
@@ -314,16 +441,29 @@
 	pjsip_generic_string_hdr_create(tdata->pool, 
 					&STR_CONTACT,
-					&pjsua.config.acc_config[acc_index].contact));
-
-    /* Duplicate text.
-     * We need to keep the text because we will display it when we fail to
-     * send the message.
+					&pjsua_var.acc[acc_id].cfg.contact));
+
+    /* Create IM data to keep message details and give it back to
+     * application on the callback
      */
-    text = pj_pool_alloc(tdata->pool, sizeof(pj_str_t));
-    pj_strdup_with_null(tdata->pool, text, str);
+    im_data = pj_pool_zalloc(tdata->pool, sizeof(*im_data));
+    im_data->acc_id = acc_id;
+    im_data->call_id = PJSUA_INVALID_ID;
+    pj_strdup_with_null(tdata->pool, &im_data->to, to);
+    pj_strdup_with_null(tdata->pool, &im_data->body, content);
+    im_data->user_data = user_data;
+
+
+    /* Set default media type if none is specified */
+    if (mime_type == NULL) {
+	mime_type = &mime_text_plain;
+    }
+
+    /* Parse MIME type */
+    pjsua_parse_media_type(tdata->pool, mime_type, &media_type);
 
     /* Add message body */
-    tdata->msg->body = pjsip_msg_body_create( tdata->pool, &mime_text,
-					      &mime_plain, text);
+    tdata->msg->body = pjsip_msg_body_create( tdata->pool, &media_type.type,
+					      &media_type.subtype, 
+					      &im_data->body);
     if (tdata->msg->body == NULL) {
 	pjsua_perror(THIS_FILE, "Unable to create msg body", PJ_ENOMEM);
@@ -332,7 +472,13 @@
     }
 
+    /* Add additional headers etc. */
+    pjsua_process_msg_data(tdata, msg_data);
+
+    /* Add route set */
+    pjsua_set_msg_route_set(tdata, &pjsua_var.acc[acc_id].route_set);
+
     /* Send request (statefully) */
-    status = pjsip_endpt_send_request( pjsua.endpt, tdata, -1, 
-				       text, &im_callback);
+    status = pjsip_endpt_send_request( pjsua_var.endpt, tdata, -1, 
+				       im_data, &im_callback);
     if (status != PJ_SUCCESS) {
 	pjsua_perror(THIS_FILE, "Unable to send request", status);
@@ -344,19 +490,21 @@
 
 
-/**
+/*
  * Send typing indication outside dialog.
  */
-PJ_DEF(pj_status_t) pjsua_im_typing(int acc_index, const pj_str_t *dst_uri, 
-				    pj_bool_t is_typing)
+PJ_DEF(pj_status_t) pjsua_im_typing( pjsua_acc_id acc_id, 
+				     const pj_str_t *to, 
+				     pj_bool_t is_typing,
+				     const pjsua_msg_data *msg_data)
 {
     const pj_str_t STR_CONTACT = { "Contact", 7 };
+    pjsua_im_data *im_data;
     pjsip_tx_data *tdata;
     pj_status_t status;
 
     /* Create request. */
-    status = pjsip_endpt_create_request( pjsua.endpt, &pjsip_message_method,
-					 dst_uri, 
-					 &pjsua.config.acc_config[acc_index].id,
-					 dst_uri, NULL, NULL, -1, NULL, &tdata);
+    status = pjsip_endpt_create_request( pjsua_var.endpt, &pjsip_message_method,
+					 to, &pjsua_var.acc[acc_id].cfg.id,
+					 to, NULL, NULL, -1, NULL, &tdata);
     if (status != PJ_SUCCESS) {
 	pjsua_perror(THIS_FILE, "Unable to create request", status);
@@ -374,5 +522,5 @@
 	pjsip_generic_string_hdr_create(tdata->pool, 
 					&STR_CONTACT,
-					&pjsua.config.acc_config[acc_index].contact));
+					&pjsua_var.acc[acc_id].cfg.contact));
 
 
@@ -381,7 +529,14 @@
 						      NULL, NULL, -1);
 
+    /* Add additional headers etc. */
+    pjsua_process_msg_data(tdata, msg_data);
+
+    /* Create data to reauthenticate */
+    im_data = pj_pool_zalloc(tdata->pool, sizeof(*im_data));
+    im_data->acc_id = acc_id;
+
     /* Send request (statefully) */
-    status = pjsip_endpt_send_request( pjsua.endpt, tdata, -1, 
-				       NULL, NULL);
+    status = pjsip_endpt_send_request( pjsua_var.endpt, tdata, -1, 
+				       im_data, &typing_callback);
     if (status != PJ_SUCCESS) {
 	pjsua_perror(THIS_FILE, "Unable to send request", status);
@@ -402,10 +557,10 @@
 
     /* Register module */
-    status = pjsip_endpt_register_module(pjsua.endpt, &mod_pjsua_im);
+    status = pjsip_endpt_register_module(pjsua_var.endpt, &mod_pjsua_im);
     if (status != PJ_SUCCESS)
 	return status;
 
     /* Register support for MESSAGE method. */
-    pjsip_endpt_add_capability( pjsua.endpt, &mod_pjsua_im, PJSIP_H_ALLOW,
+    pjsip_endpt_add_capability( pjsua_var.endpt, &mod_pjsua_im, PJSIP_H_ALLOW,
 				NULL, 1, &msg_tag);
 
